"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _immutable = require("immutable");

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var MAX_HASH_CODE = 199999999;

var ImmutableInherit =
/*#__PURE__*/
function () {
  function ImmutableInherit(createFrom) {
    _classCallCheck(this, ImmutableInherit);

    // We're going to create a _data member that will hold an immutable representation
    // of whatever we received from the constructor
    if (createFrom) {
      if ((0, _immutable.isImmutable)(createFrom)) {
        // We received an Immutable object, so use it.
        this._data = createFrom;
      } else if (_typeof(createFrom) === 'object' || createFrom instanceof Array) {
        // We received a normal JavaScript object, so let Immutable create an immutable one
        this._data = (0, _immutable.fromJS)(createFrom);
      } else {
        throw new Error('ImmutableInherit constructor called with invalid argument');
      }
    } else {
      // Constructor called with no argument, default to Map()
      this._data = new _immutable.Map({});
    } // We need an internal hash code that will be a unique identifier for this instance
    // TODO: Improve implementation to absolutely guarantee no collisions


    this._hashCode = Math.floor(Math.random() * MAX_HASH_CODE);
  }

  _createClass(ImmutableInherit, [{
    key: "getData",
    value: function getData() {
      return this._data;
    } // Part of the Immutable interface contract

  }, {
    key: "hashCode",
    value: function hashCode() {
      return this._hashCode;
    } // Another part of the Immutable interface contract

  }, {
    key: "isImmutable",
    value: function isImmutable() {
      return true;
    }
  }, {
    key: "equals",
    value: function equals(obj) {
      // This is a key method. We will return true if obj exists and is an 
      // instance of ImmutableInherit, and one of the following is true
      // - the hash codes of the two ImmutableInherit objects are identical
      // - the contained data elements are identical
      // - the two data elements are logically identical as determined by is()
      //   from the Immutable.js package
      return obj && obj instanceof ImmutableInherit && (obj.hashCode() === this._hashCode || obj.getData() === this._data || (0, _immutable.is)(obj.getData(), this._data));
    }
  }]);

  return ImmutableInherit;
}();

exports.default = ImmutableInherit;